Subject: Re: bug#52808: Guix home should not assume that all targets are dot files

From: Andrew Tropin <[email-masked]>
Date: Fri, 28 Jan 2022 13:51:57 +0300

On 2021-12-26 12:17, Nick Zalutskiy wrote:

> The following configuration results in a `~/.run` symlink being
> created. My expectation is that a `~/run` symlink is created
> instead. (ie. not a dotfile)

Some how I missed it and not documented home-files-service-type in the
manual, I'll add it soon.  Thank you for mentioning it.  It should break
this expectation :)

>> (home-environment
>>   (services
>>     (list (service
>>             home-bash-service-type
>>             (home-bash-configuration
>>           (guix-defaults? #t)))
>>       (simple-service 'my-files
>>               home-files-service-type
>>               `(("run" ,(local-file "run")))))))
>
> This applies to all other targets. My expectation is that the
> configuration should expect the exact target and not make an
> assumption that all targets are hidden files, since that allows for
> more utility:
>
>> (home-environment
>>   (services
>>     (list (service
>>             home-bash-service-type
>>             (home-bash-configuration
>>               (guix-defaults? #t)))
>>           (simple-service 'config-files
>>               home-files-service-type
>>               `(("run" ,(local-file "run"))
>>                 ("README.txt" ,(local-file "README.txt"))
>>                 (".config/guix/channels.scm" ,(local-file "config/guix
>>                 (".emacs.d/init.el" ,(local-file "emacs.d/init.el"))
>>                 (".vimrc" ,(local-file "vimrc"))
>>                 (".gitconfig" ,(local-file "gitconfig")))))))
>
> Thank you,
>
> -Nick

It's intentional and is a part of a design decision:

For example for ("config/guix/channels.scm" ,(local-file "./chans.scm"))
chans.scm goes not to ~/.config/guix/channels.scm, but to
$XDG_CONFIG_DIR/guix/channels.scm, which can be a different location
from ~/.config, absent dot should partially break this expectation.

It's a bad practice to use something without "config/..."  prefix and
generally it should be avoided, it still possible to use something
different in rare use-cases, for example for zsh: ("zshenv"
,zshenv-file-like-here), because it's hard to implement the lookup for
initial configuration file other way for shells.

You can elaborate more on what you try to achieve and I can try to give
you a recommendation how to implement it.

-- 
Best regards,
Andrew Tropin